package xenon2k4;

import jge2d.Ponto;
import jge2d.TileSet;

/**
 * <p><b>Title:</b> Xenon2k4</p>
 * <p><b>Description:</b> Representa a exploso de um objecto quando este morre. </p>
 * <p><b>Copyright:</b> IPL/ESTG(c)2004</p>
 * <p><b>Company:</b> 4thFloor</p>
 * @author Ruben Pedro
 * @author Srgio Lopes
 * @version 1.1
 */

public final class Explosao extends Figura {
	
	protected static final String GRANDE = "explosaoGrande";
	protected static final String MEDIA = "explosaoMedia";
	protected static final String PEQUENA = "explosaoPequena";


/////////////////// Constructors ///////////////////////////////////////////////

	/** Construtor
	 * 
	 * @param nome Nome da exploso
	 * @param imagens TileSets da exploso
	 * @param posicao Posio na qual a exploso vai ser colocada
	 * @param tempoActual Instante em que se inicia a animao e se coloca a exploso no jogo
	 * @param nivel Nivel ao qual a exploso pertence
	 * @param nomeAnimacao Nome da animao da exploso
	 * @param animacoes Sequncia de animaes a serem apresentadas
	 * @param tempos Durao de cada sequncia de animao (por Tile)
	 * @param opcaoAni Indica se deve terminar a animao actual ou no
	 */
  public Explosao(String nome, TileSet imagens, Ponto posicao, long tempoActual, Nivel nivel, String nomeAnimacao, int[][] animacoes, int[] tempos, boolean opcaoAni) {
    super(nome, imagens, posicao, tempoActual, nivel, nomeAnimacao, animacoes, tempos, opcaoAni);
  }

}
