package xenon2k4;

import jge2d.AnimacaoSprite;
import jge2d.Ponto;
import jge2d.Sprite;
import jge2d.TileSet;

/**
 * <p><b>Title:</b> Xenon2k4</p>
 * <p><b>Description:</b> Classe abstracta que representa todos os objectos visiveis no jogo.</p>
 * <p><b>Copyright:</b> IPL/ESTG(c)2004</p>
 * <p><b>Company:</b> 4thFloor</p>
 * @author Ruben Pedro
 * @author Srgio Lopes
 * @version 1.1
 */

public abstract class Figura {

  protected Nivel nivel;
  protected Sprite sprite;


/////////////////// Constructors ///////////////////////////////////////////////

  public Figura() {
  }

  /** Construtor
   * 
	 * @param nome Nome da sprite
	 * @param imagens TileSets da figura
	 * @param posicao Posio na qual a figura vai ser colocada
	 * @param tempoActual Instante em que se inicia a animao e se coloca a figura no jogo
	 * @param nivel Nivel ao qual a figura pertence
	 * @param nomeAnimacao Nome da animao
	 * @param animacoes Sequncia de animaes a serem apresentadas
	 * @param tempos Durao de cada sequncia de animao (por Tile)
	 * @param opcaoAni Indica se deve terminar a animao actual ou no
	 */
 	public Figura(String nome, TileSet imagens, Ponto posicao, long tempoActual, Nivel nivel, String nomeAnimacao, int[][] animacoes, int[] tempos, boolean opcaoAni) {
    this.nivel = nivel;
    sprite = new Sprite(nome, this);
    sprite.adicionarAnimacao(nomeAnimacao, new AnimacaoSprite(imagens, animacoes[0],animacoes[1], animacoes[2], tempos[0], tempos[1], tempos[2]));
    sprite.colocarEm(posicao, tempoActual);
    sprite.setAnimacao(nomeAnimacao, opcaoAni, tempoActual);
  }

}
