package xenon2k4;

import jge2d.Ponto;
import jge2d.TileSet;

/**
 * <p><b>Title:</b> Xenon2k4</p>
 * <p><b>Description:</b> Classe abstracta que representa todos os prmios do jogo.</p>
 * <p><b>Copyright:</b> IPL/ESTG(c)2004</p>
 * <p><b>Company:</b> 4thFloor</p>
 * @author Ruben Pedro
 * @author Srgio Lopes
 * @version 1.1
 */

public abstract class Premio extends Colidem {


/////////////////// Constructors ///////////////////////////////////////////////

  /** Construtor
   * 
	 * @param nome Nome do Prmio
	 * @param imagens TileSets do prmio
 	 * @param posicao Posio na qual o prmio vai ser colocado
	 * @param tempoActual Instante em que se inicia a animao e se coloca o prmio no jogo
	 * @param nivel Nivel ao qual o prmio pertence
	 * @param nomeAnimacao Nome da animao
	 * @param animacoes Sequncia de animaes a serem apresentadas
	 * @param tempos Durao de cada sequncia de animao (por Tile)
	 * @param opcaoAni Indica se deve terminar a animao actual ou no
	 */
  public Premio(String nome, TileSet imagens, Ponto posicao, long tempoActual, Nivel nivel, String nomeAnimacao, int[][] animacoes, int[] tempos, boolean opcaoAni) {
    super(nome, imagens, posicao, tempoActual, nivel, nomeAnimacao, animacoes, tempos, opcaoAni);
  }


/////////////////// Mtodos de Trata Coliso ///////////////////////////////////

  /** Trata a coliso de um componente com um prmio
   * 
   * @param componete Componente com o qual o prmio colidiu
   * @param tempoActual Instante em que colidiu
   */
  public void trataColisao(Componente componete, long tempoActual) {
  }

	/** Trata a coliso de uma nave com um prmio
	 * 
   * @param nave Nave com a qual o prmio colidiu
 	 * @param tempoActual Instante em que colidiu
 	 */
	public void trataColisao(Nave nave, long tempoActual) {
  }


/////////////////// Mtodo Morrer //////////////////////////////////////////////
	
	/* (non-Javadoc)
	 * @see xenon2k4.Colidem#morrer(long)
	 */
  public void morrer(long tempoActual) {
    super.morrer(tempoActual);
		nivel.mapa.removeSprite(sprite);
  }

}
